package com.sun.org.apache.bcel.internal.generic;

import com.sun.org.apache.bcel.internal.util.ByteSequence;
import java.io.IOException;
import java.io.DataOutputStream;

public class BIPUSH extends Instruction implements ConstantPushInstruction
{
    private byte b;
    
    BIPUSH() {
    }
    
    public BIPUSH(byte b) {
        super((short)16, (short)2);
        this.b = b;
    }
    
    @Override
    public void dump(DataOutputStream out) throws IOException {
        super.dump(out);
        out.writeByte((int)this.b);
    }
    
    @Override
    public String toString(boolean verbose) {
        return super.toString(verbose) + " " + (int)this.b;
    }
    
    @Override
    protected void initFromFile(ByteSequence bytes, boolean wide) throws IOException {
        super.setLength(2);
        this.b = bytes.readByte();
    }
    
    @Override
    public Number getValue() {
        return Integer.valueOf((int)this.b);
    }
    
    @Override
    public Type getType(ConstantPoolGen cp) {
        return Type.BYTE;
    }
    
    @Override
    public void accept(Visitor v) {
        v.visitPushInstruction(this);
        v.visitStackProducer(this);
        v.visitTypedInstruction(this);
        v.visitConstantPushInstruction(this);
        v.visitBIPUSH(this);
    }
}
